<?php

if (!defined('FORUM_ROOT'))
	die();

require FORUM_ROOT.'include/common_admin.php';

// Check permission
if ($forum_user['g_id'] != FORUM_ADMIN)
	message($lang_common['No permission']);

// Load functions
if (!defined('SURLY_FUNCTIONS_LOADED'))
	require $ext_info['path'].'/include/functions.php';

// Load the admin.php language file
require FORUM_ROOT.'lang/'.$forum_user['language'].'/admin_common.php';
require FORUM_ROOT.'lang/'.$forum_user['language'].'/admin_settings.php';

if (!isset($lang_pun_url_shortener)) {
	if (file_exists($ext_info['path'].'/lang/'.$forum_user['language'].'/'.$ext_info['id'].'.php'))
		include $ext_info['path'].'/lang/'.$forum_user['language'].'/'.$ext_info['id'].'.php';
	else
		include $ext_info['path'].'/lang/English/'.$ext_info['id'].'.php';
}

// Enable url processing
if (isset($_GET['enable_url_processing'])) {
	surly_save_config(array(
		'pun_surly_com_plugin_url_processing' => 1,
	));

	redirect(forum_link($forum_url['surly_toolbar']));
}

if (isset($_POST['reset_toolbar_id'])) {
	surly_save_config(array(
		'pun_surly_com_plugin_toolbar_id_second' => '',
	));
	redirect(forum_link($forum_url['surly_behaviour']));
}

if (isset($_POST['save'])) {

	$groups = isset($_POST['pun_surly_com_plugin_exc_users']) ?
		$_POST['pun_surly_com_plugin_exc_users'] : array();

	$toolbar_id_second = isset($_POST['pun_surly_com_plugin_toolbar_id_second']) ? trim($_POST['pun_surly_com_plugin_toolbar_id_second']) : '';

	surly_save_config(array(
		'pun_surly_com_plugin_shorten_urls' => isset($_POST['pun_surly_com_plugin_shorten_urls']) ? 1 : 0,
		'pun_surly_com_plugin_url_processing' => isset($_POST['pun_surly_com_plugin_url_processing']) ? 1 : 0,
		'pun_surly_com_plugin_exc_users' => serialize($groups),
		'pun_surly_com_plugin_toolbar_id_second' => $toolbar_id_second == $forum_config['o_pun_surly_com_plugin_toolbar_id'] ? '' : $toolbar_id_second,
	));

	if (floatval(FORUM_VERSION) >= 1.4) {
		$forum_flash->add_info($lang_admin_settings['Settings updated']);
	}

	redirect(forum_link($forum_url['surly_behaviour']), $lang_admin_settings['Settings updated']);
}

$forum_page['form_action'] = forum_link($forum_url['surly_behaviour']);
$forum_page['group_count'] = $forum_page['item_count'] = $forum_page['fld_count'] = 0;

// Setup breadcrumbs
$forum_page['crumbs'] = array(
	array($forum_config['o_board_title'], forum_link($forum_url['index'])),
	array($lang_admin_common['Forum administration'], forum_link($forum_url['admin_index'])),
	array($lang_pun_url_shortener['Sur.ly'], forum_link($forum_url['surly_toolbar'])),
	array($lang_pun_url_shortener['Behaviour'], forum_link($forum_url['surly_behaviour']))
);

$groups = array();
$query = array(
	'SELECT' => 'g.g_id, g.g_title',
	'FROM' => 'groups AS g',
    'ORDER BY' => 'g.g_title'
);

$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);

while ($group = $forum_db->fetch_assoc($result)){
	$groups[] = $group;
}

$surly_groups = empty($forum_config['o_pun_surly_com_plugin_exc_users']) ?
	array() : unserialize($forum_config['o_pun_surly_com_plugin_exc_users']);

define('FORUM_PAGE_SECTION', 'surly');
define('FORUM_PAGE', 'admin-surly_behaviour');
require FORUM_ROOT.'header.php';

// START SUBST - <!-- forum_main -->
ob_start();

include $ext_info['path'] . '/views/behaviour.php';

$tpl_temp = forum_trim(ob_get_contents());
$tpl_main = str_replace('<!-- forum_main -->', $tpl_temp, $tpl_main);
ob_end_clean();
// END SUBST - <!-- forum_main -->

require FORUM_ROOT.'footer.php';