<?php

if (!defined('FORUM_ROOT'))
	die();

require FORUM_ROOT.'include/common_admin.php';

// Check permission
if ($forum_user['g_id'] != FORUM_ADMIN)
	message($lang_common['No permission']);

// Load functions
if (!defined('SURLY_FUNCTIONS_LOADED'))
	require $ext_info['path'].'/include/functions.php';

// Load the admin.php language file
require FORUM_ROOT.'lang/'.$forum_user['language'].'/admin_common.php';
require FORUM_ROOT.'lang/'.$forum_user['language'].'/admin_settings.php';

if (!isset($lang_pun_url_shortener)) {
	if (file_exists($ext_info['path'].'/lang/'.$forum_user['language'].'/'.$ext_info['id'].'.php'))
		include $ext_info['path'].'/lang/'.$forum_user['language'].'/'.$ext_info['id'].'.php';
	else
		include $ext_info['path'].'/lang/English/'.$ext_info['id'].'.php';
}

$errDomain = '';
$warning = array();

// Delete
if (isset($_GET['delete'])) {
	$domain = isset($_GET['domain']) ? trim($_GET['domain']) : '';
	$domains = unserialize($forum_config['o_pun_surly_com_plugin_exc_domains']);

	if(in_array($domain, $domains)){
		$key = array_search($domain, $domains);
		unset($domains[$key]);

		surly_save_config(array('pun_surly_com_plugin_exc_domains' => serialize($domains)));
		if (floatval(FORUM_VERSION) >= 1.4) {
			$forum_flash->add_info($lang_admin_settings['Settings updated']);
		}

		redirect(forum_link($forum_url['surly_domains']), $lang_admin_settings['Settings updated']);
	}
}
// Update
else if (isset($_POST['add'])) {
	$array_exc_domains = array();
	$error = false;

	$domains = $_POST['pun_surly_com_plugin_exc_domains'];

	foreach ($domains as $key => $domain) {
		$domain = trim($domain);
		if ($domain == ''){
			$error = true;
			if (floatval(FORUM_VERSION) < 1.4) {
				$warning[] = $lang_pun_url_shortener['Incorrect domain'];
			} else {
				$forum_flash->add_warning($lang_pun_url_shortener['Incorrect domain']);	
			}

			continue;
		}

		$domain = str_replace("[url]","",$domain);
		$domain = str_replace("http://","",$domain);
		$domain = str_replace("https://","",$domain);

		$pattern = '!(?P<host>(?:[a-z0-9_-]+\.)+[a-z]+)!u';
		if (preg_match($pattern, strtolower($domain), $result)) {
			$domain = $result['host'];

			if (!in_array($domain, $array_exc_domains)) {
				$array_exc_domains[] = $domain;
			} else {
				$error = true;
				if (floatval(FORUM_VERSION) < 1.4) {
					$warning[] = $lang_pun_url_shortener['This domain is already added'];
				} else {
					$forum_flash->add_warning($lang_pun_url_shortener['This domain is already added']);
				}
				$errDomain = $domain;
			}

		} else {
			$error = true;

			if (floatval(FORUM_VERSION) < 1.4) {
				$warning[] = $lang_pun_url_shortener['Incorrect domain'];
			} else {
				$forum_flash->add_warning($lang_pun_url_shortener['Incorrect domain']);
			}
			$errDomain = $domain;
		}
	}

	if (!$error) {
		surly_save_config(array('pun_surly_com_plugin_exc_domains' => serialize($array_exc_domains)));
		if (floatval(FORUM_VERSION) >= 1.4) {
			$forum_flash->add_info($lang_admin_settings['Settings updated']);
		}

		redirect(forum_link($forum_url['surly_domains']), $lang_admin_settings['Settings updated']);
	}
}

$forum_page['form_action'] = forum_link($forum_url['surly_domains']);
$forum_page['group_count'] = $forum_page['item_count'] = $forum_page['fld_count'] = 0;

// Setup breadcrumbs
$forum_page['crumbs'] = array(
	array($forum_config['o_board_title'], forum_link($forum_url['index'])),
	array($lang_admin_common['Forum administration'], forum_link($forum_url['admin_index'])),
	array($lang_pun_url_shortener['Sur.ly'], forum_link($forum_url['surly_toolbar'])),
	array($lang_pun_url_shortener['Trusted domains'], forum_link($forum_url['surly_domains']))
);

$domains = empty($forum_config['o_pun_surly_com_plugin_exc_domains']) ?
	array() : unserialize($forum_config['o_pun_surly_com_plugin_exc_domains']);

if (!empty($_GET['order']) && in_array($_GET['order'], array('asc', 'desc'))) {
	$order = $_GET['order'];
	if ($_GET['order'] == 'desc') {
		arsort($domains);
	}
	else {
		asort($domains);
	}
}
else {
	$order = 'asc';
	asort($domains);
}

define('FORUM_PAGE_SECTION', 'surly');
define('FORUM_PAGE', 'admin-surly_domains');
require FORUM_ROOT.'header.php';

// START SUBST - <!-- forum_main -->
ob_start();

include $ext_info['path'] . '/views/domains.php';

$tpl_temp = forum_trim(ob_get_contents());
$tpl_main = str_replace('<!-- forum_main -->', $tpl_temp, $tpl_main);
ob_end_clean();
// END SUBST - <!-- forum_main -->

require FORUM_ROOT.'footer.php';