<?php
/*
 * Copyright (c) 2012-2013 Sur.ly
 * This file is part of Sur.ly PunBB plugin.
 * 
 * Sur.ly PunBB plugin plugin is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Sur.ly PunBB plugin is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Sur.ly PunBB plugin.  If not, see <http://www.gnu.org/licenses/>.
 */

if (!defined('FORUM')) die();

function surly_save_config($form){

    global $forum_db, $forum_config;

    foreach ($form as $key => $input) {
        // Only update option values that have changed
        if (array_key_exists('o_' . $key, $forum_config) && $forum_config['o_' . $key] != $input) {

            if ($input != '' || is_int($input)){
                $value = '\'' . $forum_db->escape($input) . '\'';
            } else {
                $value = 'NULL';
            }

            $query = array(
                'UPDATE' => 'config',
                'SET' => 'conf_value=' . $value,
                'WHERE' => 'conf_name=\'o_' . $forum_db->escape($key) . '\''
            );

            $forum_db->query_build($query) or error(__FILE__, __LINE__);
        }
    }

    // Regenerate the config cache
    if (!defined('FORUM_CACHE_FUNCTIONS_LOADED'))
        require FORUM_ROOT . 'include/cache.php';

    generate_config_cache();

    // If changed sef - remove quick-jump cache
    if (!empty($forum_config['o_sef']) && !empty($form['sef'])) {
        if ($forum_config['o_sef'] != $form['sef']) {
            clean_quickjump_cache();
        }
    }
}

function surly_get_group($userId){
    global $forum_db;
    
    if(!$userId) {
        return false;
    }

    $query = array(
        'SELECT' => 'u.group_id',
        'FROM' => 'users AS u',
        'WHERE' => 'u.id=' . $userId
    );

    $result = $forum_db->query_build($query) or error(__FILE__, __LINE__);

    return $forum_db->fetch_assoc($result);
}

function surly_get_toolbar_id() {
    global $forum_config;

    return $forum_config['o_pun_surly_com_plugin_toolbar_id_second'] 
        ? $forum_config['o_pun_surly_com_plugin_toolbar_id_second'] : $forum_config['o_pun_surly_com_plugin_toolbar_id'];
}


define('SURLY_FUNCTIONS_LOADED', 1);

?>
